package model

import (
	"time"
)

type FbPaySet struct {
	Id           int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsUse        int       `json:"is_use" xorm:"not null default 0 comment('1开启') TINYINT(1)"`
	VendorSn     string    `json:"vendor_sn" xorm:"not null comment('服务商开放平台id（服务商后台生成') VARCHAR(255)"`
	StoreId      string    `json:"store_id" xorm:"not null comment('商户门店号') VARCHAR(255)"`
	AppSecret    string    `json:"app_secret" xorm:"not null default '' comment('appSecret') VARCHAR(255)"`
	MerchantId   string    `json:"merchant_id" xorm:"not null comment('呗商户号，以服务商级接入时必传，以商户级接入时不传') VARCHAR(255)"`
	PayImg       string    `json:"pay_img" xorm:"not null comment('支付图标') VARCHAR(255)"`
	UpdateTime   time.Time `json:"update_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	AliPayUse    int       `json:"ali_pay_use" xorm:"not null default 1 comment('1开启') TINYINT(1)"`
	WechatPayUse int       `json:"wechat_pay_use" xorm:"not null default 1 comment('1开启') TINYINT(1)"`
	FastPayUse   int       `json:"fast_pay_use" xorm:"default 0 comment('1开启') TINYINT(1)"`
	AppId        string    `json:"app_id" xorm:"not null comment('付呗应用id') VARCHAR(255)"`
	OriginalId   string    `json:"original_id" xorm:"comment('original_id') VARCHAR(255)"`
}
