package model

type StationLedgerInfo struct {
	Id                               int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	MerchantOrderSn                  string `json:"merchant_order_sn" xorm:"comment('系统订单号') VARCHAR(255)"`
	Info                             string `json:"info" xorm:"comment('申请信息') TEXT"`
	AccountId                        string `json:"account_id" xorm:"comment('分账id') VARCHAR(100)"`
	Type                             string `json:"type" xorm:"comment('第三方类型 付呗--fubei') VARCHAR(50)"`
	State                            int    `json:"state" xorm:"default 0 comment('1审核中  2审核成功 3审核失败') INT(1)"`
	ReturnData                       string `json:"return_data" xorm:"comment('第三方返回信息') TEXT"`
	FailMessage                      string `json:"fail_message" xorm:"comment('失败原因') VARCHAR(255)"`
	MerchantId                       string `json:"merchant_id" xorm:"comment('商户id') VARCHAR(100)"`
	LegalPersonIdCardFrontPhoto      string `json:"legal_person_id_card_front_photo" xorm:"comment('法人证件正面照片') TEXT"`
	LegalPersonIdCardBackPhoto       string `json:"legal_person_id_card_back_photo" xorm:"comment('法人证件反面照片') TEXT"`
	SettlementPersonIdCardFrontPhoto string `json:"settlement_person_id_card_front_photo" xorm:"comment('结算人证件正面照片') TEXT"`
	SettlementPersonIdCardBackPhoto  string `json:"settlement_person_id_card_back_photo" xorm:"comment('结算人证件反面照片') TEXT"`
	BankCardPhoto                    string `json:"bank_card_photo" xorm:"comment('结算银行卡照片') TEXT"`
	LicensePhoto                     string `json:"license_photo" xorm:"comment('营业执照照片地址') TEXT"`
	AuthorizationPic                 string `json:"authorization_pic" xorm:"comment('非法人结算授权函 ') TEXT"`
	StoreEnvPhoto                    string `json:"store_env_photo" xorm:"comment('店内环境照') TEXT"`
	StoreFrontImgUrl                 string `json:"store_front_img_url" xorm:"comment('门头照') TEXT"`
	StoreCashPhoto                   string `json:"store_cash_photo" xorm:"comment('收银台照片') TEXT"`
}
