package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_pay.git/lib/fb_pay"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/offical"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/yibao_pay"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"github.com/tidwall/gjson"
	"time"
	"xorm.io/xorm"
)

func ZhiosYibao0rderShareMoneyMallExchange(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>ZhiosYibao0rderShareMoneyMallExchange<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosYibao0rderShareMoneyMallExchange(res.Body)
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosYibao0rderShareMoneyMallExchange(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosOrderShareMoney
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	var ord = make([]model.MallOrd, 0)
	eg.In("state", []string{"1", "2", "3"}).And("pay_oid=?", canalMsg.OrdId).Find(&ord)
	if len(ord) == 0 {
		return nil
	}
	payMethod := 0
	var total float64 = 0
	var fee float64 = 0
	uniqueOrderNo := ""
	payOid := ""
	uid := 0
	MerchantNo := ""
	for _, v := range ord {
		if v.State != 3 {
			return nil
		}
		uid = v.Uid
		uniqueOrderNo = v.TransactionId
		payOid = v.PayTradeNo
		payMethod = v.PayChannel
		MerchantNo = v.MerchantNo
		fee = utils.StrToFloat64(v.TotalShippingFee)
		total += utils.StrToFloat64(v.CostPrice)
	}
	total += fee
	if utils.InArr(utils.IntToStr(payMethod), []string{"21", "22"}) {
		yibaoShare(eg, payMethod, total, payOid, uniqueOrderNo, MerchantNo, uid)
	} else if utils.InArr(utils.IntToStr(payMethod), []string{"19"}) {
		fbShare(eg, canalMsg.Mid, payMethod, total, payOid, uniqueOrderNo, MerchantNo, uid)
	}
	return nil
}
func fbShare(eg *xorm.Engine, dbName string, payMethod int, total float64, payOid, uniqueOrderNo, MerchantNo string, uid int) {
	key := yibao_pay.CommKey(db.Db, true)
	zhiyingOnlineBili := utils.StrToFloat64(key["zhiyingOnlineBili"]) - 0.63
	zhiyingUnlineBili := utils.StrToFloat64(key["zhiyingUnlineBili"]) - 0.63
	bili := zhiyingUnlineBili / 100
	if payMethod == 19 {
		bili = zhiyingOnlineBili / 100
	}
	fee := total * bili
	if fee < 0.01 {
		fee = 0
	}
	fee = float64(int64(fee*100)) / 100
	req3 := map[string]string{}
	req3["key"] = utils.SerializeStr(key)
	req3["bili"] = utils.Float64ToStr(bili)
	total = float64(int64((total-fee)*100)) / 100

	var tmp = model.YibaoShareMoney{
		Oid:          utils.OrderUUID(uid),
		PayOid:       payOid,
		StoreMoney:   utils.Float64ToStr(total),
		ZhiyingMoney: utils.Float64ToStr(fee),
		Platform:     "mall",
		PayMethod:    utils.IntToStr(payMethod),
		Param:        utils.SerializeStr(req3),
		Type:         "fb",
	}
	eg.Insert(&tmp)
	//4、调用分账接口
	fbPaySet, err := GetFbMdSetting(eg, dbName)
	if err != nil {
		utils.FilePutContents("GetFbMdSettingErr", "err:"+err.Error())
		logx.Warn(err)
		return
	}
	if fbPaySet.VendorSn == "" {
		err = errors.New("没有设置相关付呗支付信息")
		utils.FilePutContents("GetFbMdSettingErr", "err:"+err.Error())
		logx.Warn(err)
		return
	}
	var (
		merchantIncomeInfo model.OnlineMerchantIncomeInfo
	)
	_, err = eg.Where("zyos_merchant_id = ? AND group_create_state = ?", 0, 1).Get(&merchantIncomeInfo)
	if merchantIncomeInfo.FbStoreId == 0 || merchantIncomeInfo.FbMerchantId == 0 {
		err = errors.New("付呗支付暂未开通")
		utils.FilePutContents("GetMerchantIncomeInfoErr", "err:"+err.Error())
		logx.Warn(err)
		return
	}
	parameters := fb_pay.GetRequestParametersByVendorSn(fbPaySet.VendorSn)
	parameters.Method = "openapi.agent.account.order.share"
	param := make(map[string]interface{})
	param["merchant_id"] = merchantIncomeInfo.FbMerchantId
	param["pay_order_sn"] = payOid
	param["merchant_order_sn"] = tmp.Oid
	param["notify_level"] = "agent"
	host := "http://csapi.fnuo123.com.cn"
	if cfg.Prd {
		host = "http://yadht.zehaochi.com.cn"
	}
	param["notify_url"] = fmt.Sprintf("%s/api/v1/o2oc/customer/pay/fb/order/share/callback", host)
	shareDetail := []map[string]interface{}{
		{
			"account_id":   "",
			"account_type": "2",
			"share_amount": total,
			"remark":       "商户分账",
		},
	}
	if fee > 0 { //TODO
		var tmp1 = map[string]interface{}{
			"account_id":   offical.SysCfgByKey(db.Db, "zhiying_fb_account"),
			"account_type": "1",
			"share_amount": fee,
			"remark":       "服务费",
		}
		shareDetail = append(shareDetail, tmp1)
	}
	param["share_detail"] = shareDetail
	utils.FilePutContents("split_account_param:::", utils.SerializeStr(param))
	fmt.Println(param)
	parameters.Nonce = utils.AnyToString(time.Now().Unix())
	parameters.SetBizContent(param)
	parameters.SetSign(fbPaySet.AppSecret)
	send, err := parameters.Send(cfg.Prd)
	if err != nil {
		utils.FilePutContents("openapiagentaccountordershare", "err:"+err.Error())
		logx.Warn(err)
		return
	}
	resp := struct {
		MerchantId         int64       `json:"merchant_id"`
		PayOrderSn         interface{} `json:"pay_order_sn"`
		MerchantPayOrderSn interface{} `json:"merchant_pay_order_sn"`
		MerchantOrderSn    string      `json:"merchant_order_sn"`
		OrderNo            interface{} `json:"order_no"`
		ShareDetail        interface{} `json:"share_detail"`
	}{}
	utils.Unserialize([]byte(send), &resp)
	tmp.Msg = send
	if orderNoStr, ok := resp.OrderNo.(string); ok {
		tmp.Oid = orderNoStr
	} else if orderNoStrArry, ok := resp.OrderNo.([]string); ok && len(orderNoStrArry) > 0 {
		tmp.Oid = orderNoStrArry[0]
	}
	tmp.Status = "SUCCESS"
	eg.Where("id=?", tmp.Id).Cols("msg,status").Update(&tmp)
	return
}
func yibaoShare(eg *xorm.Engine, payMethod int, total float64, payOid, uniqueOrderNo, MerchantNo string, uid int) {
	key := yibao_pay.CommKey(db.Db, true)
	zhiyingOnlineBili := utils.StrToFloat64(key["zhiyingOnlineBili"]) - utils.StrToFloat64(key["yibaoOnlineBili"])
	zhiyingUnlineBili := utils.StrToFloat64(key["zhiyingUnlineBili"]) - utils.StrToFloat64(key["yibaoUnlineBili"])
	allBili := utils.StrToFloat64(key["zhiyingUnlineBili"]) / 100
	bili := zhiyingUnlineBili / 100
	if payMethod == 22 {
		allBili = utils.StrToFloat64(key["zhiyingOnlineBili"]) / 100
		bili = zhiyingOnlineBili / 100
	}
	fee := total * bili
	if fee < 0.01 {
		fee = 0
	}
	param := yibao_pay.CommKey(db.Db, true)
	divideDetail := []map[string]string{
		{"amount": utils.Float64ToStr(fee), "ledgerNo": key["zhiyingMerchantNo"]},
	}
	req1 := map[string]string{
		"merchantNo":      MerchantNo,
		"orderId":         payOid,
		"uniqueOrderNo":   uniqueOrderNo,
		"divideRequestId": utils.OrderUUID(uid),
		"divideDetail":    utils.SerializeStr(divideDetail),
	}
	req3 := req1
	req3["key"] = utils.SerializeStr(key)
	req3["bili"] = utils.Float64ToStr(bili)
	req3["ledgerNo"] = key["zhiyingMerchantNo"]
	var tmp = model.YibaoShareMoney{
		Oid:          req1["divideRequestId"],
		PayOid:       payOid,
		StoreMoney:   utils.Float64ToStr(total - total*allBili),
		ZhiyingMoney: utils.Float64ToStr(total * bili),
		Platform:     "mall",
		PayMethod:    utils.IntToStr(payMethod),
		Param:        utils.SerializeStr(req3),
		Type:         "yibao",
	}
	eg.Insert(&tmp)
	if fee > 0 {
		method := "/rest/v1.0/divide/apply"
		send, err := yibao_pay.PostFormSend(method, param["appId"], param["isvPriKey"], req1)
		if err != nil || send == nil {
			if err != nil {
				tmp.Msg = err.Error()
			} else {
				tmp.Msg = "接口错误"
			}
			eg.Where("id=?", tmp.Id).Cols("msg").Update(&tmp)
			fmt.Println(err)
			return
		}
		res := utils.SerializeStr(send.Result)
		fmt.Println(res)
		if gjson.Get(res, "code").String() != "OPR00000" {
			tmp.Msg = res
			eg.Where("id=?", tmp.Id).Cols("msg").Update(&tmp)
			return
		}
		if gjson.Get(res, "status").String() != "SUCCESS" {
			tmp.Msg = res
			tmp.Status = gjson.Get(res, "status").String()
			eg.Where("id=?", tmp.Id).Cols("msg,status").Update(&tmp)
			return
		}
		tmp.Msg = res
		tmp.Status = gjson.Get(res, "status").String()
		eg.Where("id=?", tmp.Id).Cols("msg,status").Update(&tmp)
	}
	req2 := map[string]string{
		"merchantNo":      MerchantNo,
		"orderId":         payOid,
		"uniqueOrderNo":   uniqueOrderNo,
		"divideRequestId": req1["divideRequestId"] + "1",
	}
	tmp.EndOid = req2["divideRequestId"]
	tmp.EndParam = utils.SerializeStr(req2)
	eg.Where("id=?", tmp.Id).Cols("end_param").Update(&tmp)
	method2 := "/rest/v1.0/divide/complete"
	send2, err2 := yibao_pay.PostFormSend(method2, param["appId"], param["isvPriKey"], req2)
	if err2 != nil || send2 == nil {
		if err2 != nil {
			tmp.EndMsg = err2.Error()
		} else {
			tmp.EndMsg = "接口错误"
		}
		eg.Where("id=?", tmp.Id).Cols("end_msg").Update(&tmp)
		return
	}
	res2 := utils.SerializeStr(send2.Result)
	fmt.Println(res2)
	if gjson.Get(res2, "code").String() != "OPR00000" {
		tmp.EndMsg = res2
		eg.Where("id=?", tmp.Id).Cols("end_msg").Update(&tmp)
		return
	}
	tmp.EndMsg = res2
	tmp.EndStatus = gjson.Get(res2, "divideStatus").String()
	eg.Where("id=?", tmp.Id).Cols("end_msg,end_status").Update(&tmp)
	return
}
func GetFbMdSetting(engine *xorm.Engine, mid string) (*model.FbPaySet, error) {
	var (
		setting model.FbPaySet
	)
	get := setting.GetByRedis(mid)
	if get {
		return &setting, nil
	} else {
		err := setting.Get(engine)
		if err != nil {
			return nil, err
		}
		return &setting, nil
	}
}
